package ch.zhaw.catan;

import org.beryx.textio.TextIO;
import org.beryx.textio.TextIoFactory;
import org.beryx.textio.TextTerminal;

import java.util.HashMap;

public class Siedler {

    public static void main(String[] args) {

        //Spiel erstellen
        Parser parser = new Parser();
        SiedlerGame game = foundingPhase(parser);

        parser.getAction();


        //Spielfeld ausgeben







    }



    private static SiedlerGame foundingPhase(Parser parser) {
        HashMap<String, Integer> gameInfo = parser.gameStart();
        SiedlerGame game = new SiedlerGame(gameInfo.get("NumberOfWinPoints"), gameInfo.get("NumberOfPlayers"));
        for(int player = 1; player <= gameInfo.get("NumberOfPlayers"); player++){
            buildStructuresInFoundingPhase(game, parser, false);
            if(player < gameInfo.get("NumberOfPlayers")){
                game.switchToPreviousPlayer();
            }
        }
        for(int player = 1; player <= gameInfo.get("NumberOfPlayers"); player++){
            buildStructuresInFoundingPhase(game, parser, true);
            game.switchToNextPlayer();
        }
        return game;
    }


    private static void buildStructuresInFoundingPhase(SiedlerGame game, Parser parser, Boolean payout){

        parser.displayGameboard(game.getBoard().getTextView());
        parser.playerTurn(game.getCurrentPlayerFaction());


        //build Settlement
        parser.giveCoordinatesForStructures(Config.Structure.SETTLEMENT);
        boolean sucessful = false;
        do{
            if(game.placeInitialSettlement(parser.getPoint(), payout)) {
                sucessful = true;
            }
            else{
                parser.errorMessage();
            }
        }  while(!sucessful);

        //build Road
        parser.displayGameboard(game.getBoard().getTextView());
        parser.giveCoordinatesForStructures(Config.Structure.ROAD);
        sucessful = false;
        do{
            if(game.placeInitialRoad(parser.getPoint(), parser.getPoint())) {
                sucessful = true;
            }
            else{
                parser.errorMessage();
            }
        }  while(!sucessful);
    }


}
